mod Mu

incl Mtex

incl Mtexpr

incl Mprf

rem 
  \para \bf  Interpeter of primitive recursive functions.  \end 

fun/3 Sel 'Tex_f3_pr_sel'
  Sel(1,x1,1) = x1
  Sel(n+2,(x1,x),1) = x1
  Sel(n+2,(x1,x),i+2) = Sel(n+1,x,i+1)

fun/2 U 'Tex_f2_pr_u'
  U(Zx,x) = 0
  U(Sx,x) = x+1
  U(Ix(n,i),x) = Sel(n,x,i)
  U(Px(g,gs),x) = U(g,x),U(gs,x)
  U(Cx(n,m,h,gs),x) = U(h,U(gs,x))
  U(Rx(n,g,h),0,y) = U(g,y)
  U(Rx(n,g,h),x+1,y) = U(h,x,U(Rx(n,g,h),x,y),y)

