mod Ul01

incl Mtex

incl Mtexpr

incl Mprf

incl Mu

incl Mprt

loc rem 
  \para \bf  PREMIOVA ULOHA Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE 
   \end 

rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end utorok 16.5.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0506ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

rem 
  \para* \it  Termin:  \end Premiovu ulohu odovzdajte najneskor v pondelok 
  29.5.2006 do 18:00. 
  \para* \it  Format:  \end Subor \it  ul01.cl  \end ako priloha v elektronickej 
  poste. 
  \para* \it  Hodnotenie:  \end 
  \items 
   \item \para Pocet bodov za premiove ulohy: \it  5  \end. 
   \item \para Ulohy rieste \bf  samostatne!  \end 
  \end

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Symbolic Expressions.  \end 

rem 
  \para \bf  Section. Interpreter of Primitive Recursive Functions.  \end 

rem 
  \para \bf  Primitive recursive function symbols.  \end 

rem 
  \para \bf  Arithmetization of primitive recursive function symbols.  \end See 
  also the module \ft Mprf \end. 

rem 
  \para \bf  Interpeter of primitive recursive functions.  \end See also the 
  module \ft Mu \end. 

rem 
  \para \bf  Primitive recursive indices.  \end 

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (1 bod)]  \end 
  \header* fun Xc1 'Tex_f1_pr_xc1' \end Define the function \ft Xc1(m) \end such 
  that 
  \eq* 
    U(Xc1(m),x) = m
  \end

fun Xc1 'Tex_f1_pr_xc1'
  Xc1(m) = Foo

rem 
  \para \bf  Primitive recursive terms.  \end 

rem 
  \para \bf  Arithmetization of primitive recursive terms.  \end See also the 
  module \ft Mprt \end. 

rem 
  \para \bf  Denotation of primitive recursive terms.  \end 

fun/3 Den 'Tex_f3_pr_den'
  Den(n,Vt(i),v) = Sel(n,v,i)
  Den(n,Ct(m),v) = m
  Den(n,Pt(t,ts),v) = Den(n,t,v),Den(n,ts,v)
  Den(n,At(f,ts),v) = U(f,Den(n,ts,v))

rem 
  \para \bf  Explicit definitions.  \end \it  [Premiova uloha (1 bod)]  \end 
  \header* fun/2 Xedf 'Tex_f2_pr_xedf' \end \header* fun/3 F 'Tex_f3_f' \end 
  Define the binary function \ft Xedf(n,t) \end such that 
  \items 
   \item \para for every \ft n >= 1 \end, if the number \ft t \end is the code 
         of a p.r. term 
         \ft Texm_f3_subst_dotsc(Tex0_tau,x1,Texm_f2_sub(x,n)) \end with all its 
         free variables indicated then the application \ft Xedf(n,t) \end yields 
         a p.r. index of the n-ary primitive recursive function 
         \ft Texm_f0_f \end explicitly defined by 
         \eq* 
           F(x1,Tex0_dotsc,Texm_f2_sub(x,n)) = 
           Texm_f3_subst_dotsc(Tex0_tau,x1,Texm_f2_sub(x,n))
         \end
         \para or equivalently, we wish to have 
         \eq* 
           U(Xedf(n,t),v) = Den(n,t,v)
         \end
         \para for every \ft n \end-tuple \ft v \end. 
  \end
  \para \it  Remark.  \end You will need the unary function \ft Ar(f) \end 
  yielding the arity of the p.r. function symbol \ft f \end. The function is 
  defined in the module \it  Mprf  \end. 

fun/2 Xedf 'Tex_f2_pr_xedf'
  Xedf(n,t) = Foo

rem 
  \para \bf  Exercise.  \end Find p.r. indices of \ft x+y \end, \ft x*y \end and 
  \ft Texm_f2_n_exp(x,y) \end with the help of \ft Xedf(n,t) \end. 

fun/0 Xplus 'Tex_f0_pr_xplus'
  Xplus = Foo

fun/0 Xtimes 'Tex_f0_pr_xtimes'
  Xtimes = Foo

fun/0 Xexp 'Tex_f0_pr_xexp'
  Xexp = Foo

rem 
  \para \bf  Iteration.  \end \it  [Premiova uloha (1 bod)]  \end 
  \header* fun Xiter 'Tex_f1_pr_xiter' \end Define a function \ft Xiter(e) \end 
  such that 
  \eq* 
    U(Xiter(e),0,x) = x
  \end
  \eq* 
    U(Xiter(e),n+1,x) = U(e,U(Xiter(e),n,x))
  \end
  \para In other words, if \ft e \end is a p.r. index of a unary function then 
  \ft Xiter(e) \end is a p.r. index of its iteration. 

fun Xiter 'Tex_f1_pr_xiter'
  Xiter(e) = Foo

rem 
  \para \bf  Exercise.  \end Find a p.r. index of \ft x+y \end which corresponds 
  to the p.r. derivation of addition as an iteration of the successor function. 

fun/0 Xplus2 'Tex_f0_pr_xplus'
  Xplus2 = Foo

rem 
  \para \bf  Parameterless primitive recursion.  \end \it  [Premiova uloha (1 
  bod)]  \end \header* fun/2 Xrec0 'Tex_f2_pr_xrec0' \end 
  \header* fun F 'Tex_f1_f' \end \header* fun/2 H 'Tex_f2_h' \end 
  \header* fun/0 M 'Tex_f0_m' \end Define a function \ft Xrec0(m,e) \end 
  satisfying 
  \eq* 
    U(Xrec0(m,e),0) = m
  \end
  \eq* 
    U(Xrec0(m,e),x+1) = U(e,x,U(Xrec0(m,e),x))
  \end
  \para In other words, if \ft M \end is a constant and \ft e \end is a p.r. 
  index of a binary function \ft H(x,a) \end then \ft Xrec0(m,e) \end is a p.r. 
  index of the unary function \ft F(x) \end defined by following parameterless 
  primitive recursion: 
  \def 
    fun F 'Tex_f1_f'
    F(0) = M
    F(x+1) = H(x,F(x))
  \end

fun/2 Xrec0 'Tex_f2_pr_xrec0'
  Xrec0(m,e) = Foo

rem 
  \para \bf  Exercise.  \end Find a p.r. index of \ft x-1 \end which corresponds 
  to the derivation of the predecessor function by parameterless recursion. 

fun/0 Xpred 'Tex_f0_pr_xpred'
  Xpred = Foo

rem 
  \para \bf  Exercise.  \end Find a p.r. index of \ft x-y \end which corresponds 
  to the p.r. derivation of modified subtraction as an iteration of the 
  predecessor function. 

fun/0 Xminus 'Tex_f0_pr_xminus'
  Xminus = Foo

rem 
  \para \bf  Parametric function (Kleene).  \end \it  [Premiova uloha (1 bod)] 
   \end \header* fun/2 Xparam 'Tex_f2_pr_xparam' \end Define the function 
  \ft Xparam(e,x) \end such that 
  \eq* 
    U(Xparam(e,x),y) = U(e,x,y)
  \end

fun/2 Xparam 'Tex_f2_pr_xparam'
  Xparam(e,x) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

